Bug 672428 (CVE-2010-4655) - CVE-2010-4655 kernel: heap contents leak for CAP_NET_ADMIN via ethtool ioctl
Summary: CVE-2010-4655 kernel: heap contents leak for CAP_NET_ADMIN via ethtool ioctl
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2010-4655
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 672430 672431 672432 672433 672434 672435 672436
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-01-25 04:21 UTC by Eugene Teo (Security Response)
Modified: 2019-09-29 12:42 UTC (History)
18 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-07-29 13:42:23 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2011:0263 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 4.9 kernel security and bug fix update 2011-02-16 15:14:55 UTC
Red Hat Product Errata RHSA-2011:0303 normal SHIPPED_LIVE Moderate: kernel security and bug fix update 2011-03-01 20:29:26 UTC
Red Hat Product Errata RHSA-2011:0330 normal SHIPPED_LIVE Important: kernel-rt security and bug fix update 2011-03-10 20:04:13 UTC
Red Hat Product Errata RHSA-2011:0421 normal SHIPPED_LIVE Important: kernel security and bug fix update 2011-04-08 02:56:45 UTC

Description Eugene Teo (Security Response) 2011-01-25 04:21:37 UTC
Several other ethtool functions leave heap uncleared (potentially) by drivers. Some interfaces appear safe (eeprom, etc), in that the sizes are well controlled. In some situations (e.g. unchecked error conditions), the heap will remain unchanged in areas before copying back to userspace. Note that these are less of an issue since these all require CAP_NET_ADMIN.

ethtool_get_rxfh_indir (intro in a5b6ee29 v2.6.36-rc1)
ethtool_get_rx_ntuple (intro in 15682bc4 v2.6.34-rc1)
ethtool_get_regs changed to vmalloc in a77f5db3 v2.6.37-rc1

Upstream commit:
http://git.kernel.org/linus/b00916b189d13a615ff05c9242201135992fcda3

Reference:
https://lkml.org/lkml/2010/10/7/297

Acknowledgements:

Red Hat would like to thank Kees Cook for reporting this issue.

Comment 3 Eugene Teo (Security Response) 2011-01-25 05:13:29 UTC
ethtool_get_rxfh_indir (introduced in a5b6ee29 v2.6.36-rc1)
ethtool_get_rx_ntuple (introduced in 15682bc4 v2.6.34-rc1)
ethtool_get_regs -> changed to vmalloc in a77f5db3 v2.6.37-rc1
   missing zeroing, posted a patch, see
   http://marc.info/?l=linux-kernel&m=129593098003553&w=2

ethtool_get_rx{fh_indir,_ntuple} are not backported to rhel-4/5/6/mrg-1. We just need to backport ethtool_get_regs() changes.

Comment 4 Eugene Teo (Security Response) 2011-01-28 01:43:52 UTC
(In reply to comment #3)
[...]
> ethtool_get_rx{fh_indir,_ntuple} are not backported to rhel-4/5/6/mrg-1. We
> just need to backport ethtool_get_regs() changes.

http://git.kernel.org/linus/b7c7d01aaed1f71d9afe815a569f0a81465a1744

Comment 5 errata-xmlrpc 2011-02-16 15:15:31 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 4

Via RHSA-2011:0263 https://rhn.redhat.com/errata/RHSA-2011-0263.html

Comment 6 errata-xmlrpc 2011-03-01 20:29:45 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5

Via RHSA-2011:0303 https://rhn.redhat.com/errata/RHSA-2011-0303.html

Comment 7 errata-xmlrpc 2011-03-10 20:05:21 UTC
This issue has been addressed in following products:

  MRG for RHEL-5

Via RHSA-2011:0330 https://rhn.redhat.com/errata/RHSA-2011-0330.html

Comment 8 errata-xmlrpc 2011-04-08 02:57:41 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2011:0421 https://rhn.redhat.com/errata/RHSA-2011-0421.html


Note You need to log in before you can comment on or make changes to this bug.